function [st, stBC] = stencils(x,y,ns,bi)
 
   N = length(x); st = zeros(N,ns);
   
   for i=1:N  % stencils for derivative approximation 
      x0 = x(i); y0 = y(i);
      r = (x(:)-x0).^2 + (y(:)-y0).^2;   
      [r,ix] = sort(r);
      st(i,:) = ix(1:ns);       
   end 
   
   nb = length(bi); % stencils for no flux BCs 
   for i=1:nb
      stBC(i,:) = [i st(i,find(st(i,:)>nb))]; 
   end             
            
